'
' This class provides all methods used to access stored procedures for the purpose of:
' Displaying Data...Updating Data...Inserting Data...
'
Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.HttpContext

Public Class BusinessLogic



    '-- returns 0=false, 1=true
    Shared Function getDbBit(ByVal tmp As Object, Optional ByVal vartype As String = "") As Integer
        Dim tmpbit As Boolean = False
        Dim newint As Integer = 0

        vartype = LCase(vartype)
        Try
            If (vartype = "radiobuttonlist") Then
                tmp = CType(tmp, RadioButtonList).SelectedItem.Value
            ElseIf (vartype = "checkboxlist") Then
                tmp = CType(tmp, CheckBoxList).SelectedItem.Value
            End If
        Catch ex As Exception
            HttpContext.Current.Trace.Write("error getDbBit.ctype: " & ex.StackTrace)
        End Try
        Try
            If (tmp Is Nothing) Then
                newint = 0
            Else
                tmpbit = Convert.ToBoolean(tmp)
                If (tmpbit) Then newint = 1
            End If
        Catch e As Exception
            '--check to see if already 1/0
            Try
                newint = CInt(tmp)
                If (newint < 0) Or (newint > 1) Then newint = 0
            Catch e2 As Exception
            End Try
        End Try

        Return newint
    End Function

    Shared Function getCurrentLanguage() As String
        Dim currLang As String = ""
        Dim strError As String = ""
        Dim objdata As New RvDataUtil.DataUtil
        Try

            Dim alist As New ArrayList()
            alist.Add(HttpContext.Current.Session.SessionID)
            alist.Add(HttpContext.Current.Request.ServerVariables("remote_addr"))
            alist.Add(HttpContext.Current.Request.ServerVariables("http_user_agent"))

            Dim dr As SqlDataReader = objdata.GetDataReaderSP("usp_getCurrLanguage", alist, strError)
            If (strError <> "") Then
                HttpContext.Current.Trace.Warn("usp_getCurrLanguage.error=" & strError)
            End If
            If (dr.Read) Then
                currLang = RvDataUtil.Formatting.NotNull(dr("language"))
            End If
            dr.Close()
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("usp_getCurrLanguage.error=" & ex.Message & "; " & ex.StackTrace)
        End Try

        objdata.CloseConnection()

        Return currLang
    End Function

    Shared Function setCurrentLanguage(ByVal lang As String) As String
        Dim currLang As String = ""
        Dim objdata As New RvDataUtil.DataUtil
        Dim alist As New ArrayList()
        alist.Add(HttpContext.Current.Session.SessionID)
        alist.Add(HttpContext.Current.Request.ServerVariables("remote_addr"))
        alist.Add(HttpContext.Current.Request.ServerVariables("http_user_agent"))
        alist.Add(lang)

        Dim dr As SqlDataReader = objdata.GetDataReaderSP("usp_getCurrLanguage", alist)
        If (dr.Read) Then
            currLang = RvDataUtil.Formatting.NotNull(dr("language"))
        End If
        dr.Close()
        objdata.CloseConnection()

        Return currLang
    End Function

    Shared Function GetSessionID() As String
        Dim _Session As HttpContext = HttpContext.Current
        Dim strASPSessionID As String = _Session.Session.SessionID
        Return strASPSessionID
    End Function


    Shared Function UpdateSession(ByVal strReferer As String, ByVal strHeaders As String, ByVal lngUserID As Long, ByVal strIP As String) As Boolean
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Add(GetSessionID)
        paWork.Add(strReferer)
        paWork.Add(strHeaders)
        paWork.Add(lngUserID)
        paWork.Add(strIP)
        If objData.ExecuteSP("usp_UpdateSession", paWork) Then
            Return True
        Else
            Return False
        End If
        objData.CloseConnection()
        objData = Nothing
        paWork = Nothing
    End Function
    Shared Function UpdateSSLSession(ByVal aspSessionID As String) As Boolean
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Add(aspSessionID)
        paWork.Add(GetSessionID)
        If objData.ExecuteSP("usp_UpdateSSLSession", paWork) Then
            Return True
        Else
            Return False
        End If
        objData.CloseConnection()
        objData = Nothing
        paWork = Nothing
    End Function

    Shared Function GetDataField(ByVal strTable As String, ByVal strField As String, ByVal strWhere As String, Optional ByVal strOrderBy As String = "", Optional ByRef strError As String = "") As String
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        Dim dr As System.Data.SqlClient.SqlDataReader
        paWork.Clear()
        paWork.Add(strTable)
        paWork.Add(strField)
        paWork.Add(strWhere)
        paWork.Add(strOrderBy)
        Try
            dr = objData.GetDataReaderSP("usp_GetData", paWork)
            While dr.Read
                GetDataField = RvDataUtil.Formatting.NotNull(dr.Item(0), "")
            End While
            dr.Close()
        Catch
        End Try
        dr = Nothing
        objData.CloseConnection()
        objData = Nothing
    End Function
    Shared Function GetSessionData(ByRef lngUserID As Long, ByRef intRoleType As Integer, ByRef strusername As String, _
                    ByRef strfirstname As String, ByRef strlastname As String, ByRef stremail As String, Optional ByRef strError As String = "") As Boolean
        GetSessionData = True
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Clear()
        paWork.Add(GetSessionID)
        Try
            Dim dr As SqlClient.SqlDataReader = objData.GetDataReaderSP("usp_GetSessionData", paWork)
            While dr.Read
                lngUserID = RvDataUtil.Formatting.NotNull(dr.Item("UserID"), 0)
                intRoleType = RvDataUtil.Formatting.NotNull(dr.Item("roletype"), 0)
                strusername = RvDataUtil.Formatting.NotNull(dr.Item("username"), "")
                strfirstname = RvDataUtil.Formatting.NotNull(dr.Item("firstname"), "")
                strlastname = RvDataUtil.Formatting.NotNull(dr.Item("lastname"), "")
                stremail = RvDataUtil.Formatting.NotNull(dr.Item("email"), "")

            End While
            Try
                dr.Close()
            Catch ex As Exception
            End Try
            dr = Nothing
            objData.CloseConnection()
            objData = Nothing
        Catch ex As Exception
            GetSessionData = False
            strError += ex.ToString
        End Try
    End Function
    Shared Function GetAllLoginInfo_admin(ByRef lngUserID As Long, ByRef strSecurityLevel As String, ByRef strUserName As String, ByRef strPassword As String, ByRef strName As String, ByRef strcamefrom As String) As Boolean
        'Dim intCount As Integer
        Dim paWork As ArrayList
        Dim strSql As String
        Dim dr As SqlDataReader
        Dim objDataSet As New RvDataUtil.DataUtil
        Dim strError As String = ""

        paWork = New ArrayList
        paWork.Add(GetSessionID)
        strSql = ("usp_GetUserInfo_admin")
        Try
            dr = objDataSet.GetDataReaderSP(strSql, paWork, strError)
            If (strError <> "") Then
                HttpContext.Current.Trace.Warn("getAllloginInfo_Admin", "usp_getUserInfo_admin.error=" & strError)
            End If
            If (dr.Read) Then
                lngUserID = dr("userID")
                strUserName = dr("username")
                strPassword = dr("password")
                strName = RvDataUtil.Formatting.NotNull(dr("realname"), "")
                strSecurityLevel = RvDataUtil.Formatting.NotNull(dr("security_Level"), "")
                GetAllLoginInfo_admin = True
            Else
                GetAllLoginInfo_admin = False
            End If
            dr.Close()
            dr = Nothing
            objDataSet.CloseConnection()
            objDataSet = Nothing
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("error: " & ex.Message & "; " & ex.StackTrace)
            GetAllLoginInfo_admin = False
        End Try
    End Function

    Shared Function GetLoginInfo_admin(ByVal strWhich As String) As String
        'HttpContext.Current.Trace.Write("GetLoginInfo_admin", "strWhich=" & strWhich)
        If Len(strWhich) > 0 Then strWhich = LCase(strWhich)
        Dim lngUserID As Long = 0
        Dim strName As String = ""
        Dim strPassword As String = ""
        Dim strUsername As String = ""
        Dim strcamefrom As String = ""
        Dim strSecurityLevel As String = ""

        GetAllLoginInfo_admin(lngUserID, strSecurityLevel, strUsername, strPassword, strName, strcamefrom)
        'Select Case intWhich
        If (strWhich = "userid") Then
            Return lngUserID
        ElseIf (strWhich = "username") Then
            Return strUsername
        ElseIf (strWhich = "password") Then
            Return strPassword
        ElseIf (strWhich = "fullname") Or (strWhich = "name") Then
            Return strName
        ElseIf (strWhich = "security") Or (strWhich = "securitylevel") Then
            Return strSecurityLevel
        End If
        Return ""
    End Function
    Shared Function IsLoggedIn_admin() As Boolean
        HttpContext.Current.Trace.Warn("inside isLoggedIn_Admin")
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        Dim strError As String = ""
        Dim intUserId As Integer = 0

        paWork.Add(GetSessionID)
        paWork.Add(0)   '--userID
        Try
            HttpContext.Current.Trace.Write("sessionID=" & GetSessionID())
            Dim sUserID As String = objData.GetDataOutput("usp_IsLoggedIn_admin", "@userID", paWork, strError)
            If IsNumeric(sUserID) And (sUserID <> "") Then
                intUserId = CLng(sUserID)
            Else
                intUserId = 0
            End If
            If (strError <> "") Then
                HttpContext.Current.Trace.Warn("sUserID=" & sUserID & ", usp_isLoggedIn_Admin.error=" & strError)
            End If
            HttpContext.Current.Trace.Warn("isLoggedIn_admin", "userID=" & intUserId)
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("Error = " & ex.Message & "; " & ex.StackTrace)
        End Try

        objData.CloseConnection()
        objData = Nothing

        If intUserId > 0 Then
            Return True
        Else
            Return False
        End If
    End Function
    Shared Function IsLoggedIn() As Boolean
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        Dim strError As String = ""

        Dim intUserId As Long = 0
        Dim strUserID As String = ""
        paWork.Add(GetSessionID)
        paWork.Add(0)
        Try
            strUserID = objData.GetDataOutput("usp_IsLoggedIn", "@userID", paWork, strError)
            If (strError <> "") Then
                HttpContext.Current.Trace.Warn("isLoggedIn", "usp_isLoggedIn: " & strError)
            End If
            intUserId = RvDataUtil.Formatting.getDbIntNull(strUserID, 0)
            If intUserId > 0 Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            'clsError.ProcessErrors("IsLoggedIn", Err.Number, ex.ToString, Err.Source, "This is in BusinessLogic")
            HttpContext.Current.Response.Write("Error = " & ex.ToString)
        End Try
        objData.CloseConnection()
        objData = Nothing
    End Function

    Shared Function LoginUser_admin(ByVal struserName As String, ByVal strPassword As String) As Integer
        Dim objData As New RvDataUtil.DataUtil
        Dim returnval As Integer = 2
        Dim paWork As New ArrayList
        If Len(struserName) > 0 And Len(strPassword) > 0 Then
            Dim uname As String = Replace(struserName, "'", "''")
            Dim pwd As String = Replace(strPassword, "'", "''")

            '--Step One: see if this is a valid login
            Dim query As String = ""
            Dim strError As String = ""

            Dim dr As SqlDataReader
            objData.paramsClear()
            objData.paramsAdd("username", SqlDbType.VarChar, struserName)
            objData.paramsAdd("password", SqlDbType.VarChar, strPassword)
            objData.paramsAdd("sessionid", SqlDbType.VarChar, HttpContext.Current.Session.SessionID)

            dr = objData.ExecDataReader("usp_loginUser_admin", strError)
            If (strError <> "") Then
                HttpContext.Current.Trace.Warn("loginUser_admin", "error=" & strError)
            End If
            If (dr.Read) Then
                HttpContext.Current.Trace.Write("loginUser", "found record for '" & uname & "'")

                returnval = 1    '--all logged in okay :)
            Else
                returnval = 2    '--bad login
            End If
            dr.Close()
            dr = Nothing
        Else
            Return False
        End If
        objData.CloseConnection()
        objData = Nothing
        paWork = Nothing

        Return returnval
    End Function


    '-- 1=Okay, 2=Bad, 3=New Password
    Shared Function LoginUser(ByVal struserName As String, ByVal strPassword As String) As Integer
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        Dim returnval As Integer = 2
        If Len(struserName) > 0 And Len(strPassword) > 0 Then
            Dim uname As String = Replace(struserName, "'", "''")
            Dim pwd As String = Replace(strPassword, "'", "''")

            '--Step One: see if this is a valid login
            Dim query As String = ""

            paWork.Add(struserName)
            paWork.Add(strPassword)
            paWork.Add(GetSessionID)
            paWork.Add(HttpContext.Current.Request.ServerVariables("remote_addr"))
            paWork.Add(HttpContext.Current.Request.ServerVariables("http_user_agent"))
            paWork.Add(0)   '--userID

            Dim strUserID As String = objData.GetDataOutput("usp_loginUser", "@userID", paWork)
            HttpContext.Current.Trace.Warn("loginuser", "strUserID=" & strUserID)
            If IsNumeric(strUserID) And (strUserID <> "0") And (strUserID <> "") Then
                returnval = 1
            Else
                returnval = 2
            End If
        End If
        objData.CloseConnection()
        objData = Nothing
        paWork = Nothing

        Return returnval
    End Function

    Shared Function Logout() As Boolean
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Add(GetSessionID)
        Try
            Return objData.ExecuteSP("usp_logout", paWork)
        Catch ex As Exception
            HttpContext.Current.Response.Write("Error = " & ex.ToString)
        End Try
        objData.CloseConnection()
        objData = Nothing
    End Function
    Shared Function Logout_admin() As Boolean
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Add(GetSessionID)
        Try
            Return objData.ExecuteSP("usp_logout_admin", paWork)
        Catch ex As Exception
            HttpContext.Current.Response.Write("Error = " & ex.ToString)
        End Try
        objData.CloseConnection()
        objData = Nothing
    End Function

    Shared Function ForgotPassword(ByVal struserName As String) As DataSet
        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Add(struserName)
        Dim ds As DataSet = objData.GetDataSetSP("usp_ForgotPassword", paWork)
        ForgotPassword = ds
        ds = Nothing
        objData.CloseConnection()
        objData = Nothing
    End Function

    Shared Function ChangePW(ByVal newpw As String, ByVal REMOTE_ADDR As String, ByVal HTTP_REFERER As String) As Boolean

        Dim objData As New RvDataUtil.DataUtil
        Dim paWork As New ArrayList
        paWork.Add(GetSessionID)
        paWork.Add(newpw)
        paWork.Add(REMOTE_ADDR)
        paWork.Add(HTTP_REFERER)
        Try
            Return objData.ExecuteSP("usp_ChangePW", paWork)
        Catch ex As Exception
            HttpContext.Current.Response.Write("Error = " & ex.ToString)
        End Try

        objData.CloseConnection()
        objData = Nothing
        paWork = Nothing
    End Function

    Shared Function GetAllLoginInfo(ByVal lngprofileid As Long, ByRef companyname As String, ByRef federalid As String, ByRef industry As String, ByRef login As String, ByRef password As String, ByRef contactemail As String, ByRef customerid As Long, ByRef industryid As Long, ByRef lockforedit As Boolean) As Boolean
        Dim paWork As ArrayList
        Dim strSql As String = ""
        Dim dr As SqlDataReader
        Dim objDataSet As New RvDataUtil.DataUtil

        paWork = New ArrayList
        paWork.Add(lngprofileid)
        strSql = ("usp_GetCustomerInfo ")
        Try
            dr = objDataSet.GetDataReaderSP(strSql, paWork)
            If Not dr.IsClosed Then
                While dr.Read()
                    companyname = dr.Item(0)
                    federalid = dr.Item(1)
                    industry = dr.Item(2)
                    login = dr.Item(3)
                    password = dr.Item(4)
                    contactemail = dr.Item(5)
                    customerid = dr.Item(6)
                    industryid = dr.Item(7)
                    lockforedit = dr.Item(8)

                End While
                GetAllLoginInfo = True
            Else
                GetAllLoginInfo = False
            End If
            dr.Close()
            dr = Nothing
            objDataSet.CloseConnection()
            objDataSet = Nothing
        Catch ex As Exception
            GetAllLoginInfo = False
        End Try
    End Function


    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub


    ' credit card processing functions
    '-------------------------------------------------
    Public Shared Function IsValidCreditCard(ByVal intMonth As Integer, ByVal intyear As Integer, _
                    ByVal strcc As String, ByVal strcctype As String, _
                    ByRef InfoMessage As String, Optional ByVal checkCardNumber As Boolean = True) As Boolean
        Dim objutil As New RvDataUtil.DataUtil
        '--RV 9/6/06 credit cards with exp date of 09/06 actually expire 10/1/2006
        If (intMonth < 12) Then
            intMonth = intMonth + 1
        Else
            intMonth = 1
            intyear = intyear + 1
        End If
        Dim dtDate As Date = New Date(intyear, intMonth, 1)
        If Today > dtDate Then
            'objutil.JavaAlert(page, "Your credit card has expired.")
            InfoMessage = "Your credit card has expired."
            Return False
            Exit Function
        End If
        If (checkCardNumber) Then
            Dim strResults As String = objutil.ValidateCCNumber(strcc)
            HttpContext.Current.Trace.Warn("isValidCreditCard", "strResults=" & strResults & ", strCCtype=" & strcctype)
            If strResults.ToString.ToUpper <> strcctype.ToString.ToUpper Then
                'objutil.JavaAlert(page, "The Card Number is invalid.")
                InfoMessage = "The Card Number is invalid."
                Return False
                Exit Function
            End If
        End If
        objutil.CloseConnection()
        objutil = Nothing
        Return True
    End Function




End Class
