Imports System.IO
Imports System.Data.SqlClient
Imports System.Data
Imports RvDataUtil.Formatting



Public Class admin_portfolio
    Inherits System.Web.UI.Page


    Dim count As Integer = 0

    Public siteURL As String = ""
    Dim objData As New RvDataUtil.DataUtil
    Dim aList As New ArrayList()
    Dim strError As String = ""

    Dim idfield As String = "portfolioID"
    Dim tablename As String = "tblPortfolio"
    Public pagetitle As String = "Portfolio"


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        siteURL = ConfigurationManager.AppSettings("siteURL")

        If (Not BusinessLogic.IsLoggedIn_admin) Then
            Response.Redirect("~/admin/admin.aspx")
        End If

        If (Not IsPostBack) Then
            Try

                binddgList()

                Dim backcolor As String = ConfigurationManager.AppSettings("backcolor")
                Dim forecolor As String = ConfigurationManager.AppSettings("forecolor")
                Me.btnSubmit.ForeColor = System.Drawing.ColorTranslator.FromHtml(backcolor)
                Me.btnSubmit.BackColor = System.Drawing.ColorTranslator.FromHtml(forecolor)
                Me.btnSubmit.Font.Bold = True

                Me.dgList.HeaderStyle.BackColor = System.Drawing.ColorTranslator.FromHtml(backcolor)
                Me.dgList.HeaderStyle.ForeColor = System.Drawing.ColorTranslator.FromHtml(forecolor)
                Me.dgList.HeaderStyle.Font.Bold = True

            Catch ex As Exception
                Trace.Warn("Error: " & ex.Message & ", " & ex.StackTrace)
            End Try
        End If
    End Sub

    Sub click_search(ByVal s As Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        binddgList()
    End Sub


    '---------------------------------------------
    ' displaying list 
    '---------------------------------------------
    Private Sub binddgList()
        '-- load up the datagrid now
        Dim query As String = ""

        Dim sort As String = "PortfolioName"
        Dim qrywhere As String = "(1=1)"
        If (Me.txtSearch_name.Text <> "") Then
            Dim srch As String = Replace(Me.txtSearch_name.Text, "'", "''")
            qrywhere += " and ((category like '%" & srch & "%') or (PortfolioName like '%" & srch & "%'))"
        End If
        If Len(ViewState("sortPhrase")) > 0 Then sort = ViewState("sortPhrase")

        query = "select c.category, g.* from tblPortfolio g " & _
                " Left join tblCategory c on g.categoryID=c.categoryID " & _
                " Where " & qrywhere & " Order By " & sort

        Dim ds As DataSet = objData.GetValueDataSet(query, "list", "", strError)
        Trace.Warn("strError=" & strError)
        objData.CloseConnection()

        If (ds.Tables(0).Rows.Count = 0) Then
            Me.dgList.Visible = False
            Me.litMessage.Text = "There are currently no portfolio items."
        Else
            If (ds.Tables(0).Rows.Count < Me.dgList.PageSize) Then
                Me.dgList.PagerStyle.Visible = False
            Else
                Me.dgList.PagerStyle.Visible = True
            End If
            Me.dgList.Visible = True
            Me.litMessage.Text = "<br>There are " & ds.Tables(0).Rows.Count & " records"
        End If
        Me.dgList.DataKeyField = idfield
        Me.dgList.DataSource = ds
        Me.dgList.DataBind()



        ds = Nothing
        objData.CloseConnection()
    End Sub

    Sub dgList_onitemdatabound(ByVal s As Object, ByVal e As DataGridItemEventArgs) Handles dgList.ItemDataBound
        If (e.Item.ItemType = ListItemType.AlternatingItem) Or (e.Item.ItemType = ListItemType.Item) Then
            Try
                CType(e.Item.FindControl("litDatagridID"), Literal).Text = objData.Nz(e.Item.DataItem(idfield), "")
                Trace.Write("dgList", "litDatagridID=" & objData.Nz(e.Item.DataItem(idfield), ""))

            Catch ex As Exception
                Trace.Warn("OnItemDataBound error: " & ex.StackTrace)
            End Try

            If e.Item.ItemType = ListItemType.Item Then
                e.Item.Attributes.Add("onmouseout", "this.style.backgroundColor='white'")
            End If
            If e.Item.ItemType = ListItemType.AlternatingItem Then
                e.Item.Attributes.Add("onmouseout", "this.style.backgroundColor='#f0f3ff'")
            End If
            'e.Item.Attributes.Add("onmouseover", "this.style.backgroundColor='" & headerHead_inc.getAccentBg() & "'")
            e.Item.Attributes.Add("onmouseover", "this.style.backgroundColor='#f0f0a0'")

        ElseIf (e.Item.ItemType = ListItemType.EditItem) Then
        End If

        Dim lb As ImageButton = CType(e.Item.FindControl("ibtnDel"), ImageButton)
        If Not lb Is Nothing Then
            lb.Attributes.Add("onClick", "return confirm('Are you sure you wish to delete this item?\nID=" & e.Item.DataItem(idfield) & "')")
        End If
    End Sub
    Sub dgList_command(ByVal s As Object, ByVal e As DataGridCommandEventArgs)
        Trace.Write("command=" & e.CommandName.ToString())
        If (e.CommandName.ToString() = "Update") Then
        ElseIf (e.CommandName.ToString() = "Delete") Then
            Try
                Dim ID As String = CType(e.Item.FindControl("litDatagridID"), Literal).Text
                Trace.Write("IN DELETE. ID=" & ID)
                Dim dgi As DataGridItem = Me.dgList.Items(e.Item.ItemIndex)

                Dim qry As String = "DELETE From " & tablename & " WHERE " & idfield & "=" & ID
                objData.GetValueDataSet(qry, "table", "")

                objData.CloseConnection()
                dgList.EditItemIndex = -1
                Me.binddgList()
            Catch ex As Exception
                Trace.Warn("deleting...", "Error: " & ex.Message & "; " & ex.StackTrace)
            End Try

        ElseIf (e.CommandName.ToString() = "Edit") Then
            Dim ID As String = CType(e.Item.FindControl("litDatagridID"), Literal).Text
            Me.loadForm(ID)
        End If
    End Sub
    Sub dgList_SortCommand(ByVal s As Object, ByVal e As DataGridSortCommandEventArgs)
        Trace.Write("inside sortCommand=" & e.SortExpression.ToString)
        Dim sort As String = e.SortExpression
        If (sort = "ID") Then sort = idfield
        If (ViewState("sortPhrase") = sort) Then
            sort += " desc"
        End If
        ViewState("sortPhrase") = sort
        dgList.CurrentPageIndex = 0
        binddgList()
    End Sub
    Sub dgList_PageIndexChanged(ByVal s As Object, ByVal e As DataGridPageChangedEventArgs)
        dgList.CurrentPageIndex = e.NewPageIndex
        binddgList()
    End Sub




    Public Sub ShowList(ByVal sender As Object, ByVal e As System.EventArgs)
        Trace.Write("showlist...")
        Me.pnlDatagrid.Visible = True
        Me.pnlEditForm.Visible = False
    End Sub
    Public Sub AddNew(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.loadForm("")
    End Sub


    Sub loadForm(Optional ByVal ID As String = "")
        Trace.Write("inside LoadForm.ID=" & ID)
        Me.pnlDatagrid.Visible = False
        Me.pnlEditForm.Visible = True

        If Len(ID) > 0 And IsNumeric(ID) Then
            litEditForm.Text = "Edit " & pagetitle & ":"
        Else
            litEditForm.Text = "Add New " & pagetitle & ":"
            ID = "-1"
        End If

        Try
            SiteLogic.populate_genericListPlain(drpcategoryID, "tblcategory", "categoryID", "category")


            Dim query As String = ""
            If (ID = "") Then ID = "-1"

            Dim p As CSL.Classes.Portfolio = CSL.Classes.PortfolioManager.GetItem(ID)
            If (Not p Is Nothing) Then
                Me.litID.Text = p.PortfolioID
                Me.txtPortfolioName.Text = p.PortfolioName
                Me.txtPortfolioDescription.Text = p.PortfolioDescription
                Me.drpcategoryID.SelectedIndex = drpcategoryID.Items.IndexOf(drpcategoryID.Items.FindByValue(p.CategoryID))
                Me.txtImage_large.Text = p.Image_large
                Me.txtImage_thumb.Text = p.Image_thumb

                If (p.DefaultCategoryImageFlag) Then
                    Me.rblDefaultCategoryImageFlag.SelectedIndex = 0
                Else
                    Me.rblDefaultCategoryImageFlag.SelectedIndex = 1
                End If
                If (p.ActiveFlag) Then
                    Me.rblActive.SelectedIndex = 0
                Else
                    Me.rblActive.SelectedIndex = 1
                End If
                Me.txtSortOrder.Text = p.SortOrder
                Me.litCreateDate.Text = p.CreateDate
                If (p.ModifyDate > DateTime.MinValue) Then
                    Me.litModifyDate.Text = p.ModifyDate
                Else
                    Me.litModifyDate.Text = ""
                End If
            Else
                Me.litID.Text = ID
                Me.txtPortfolioName.Text = ""
                Me.txtPortfolioDescription.Text = ""
                Me.drpcategoryID.SelectedIndex = -1
                Me.txtImage_thumb.Text = ""
                Me.txtImage_large.Text = ""
                Me.rblDefaultCategoryImageFlag.SelectedIndex = 1
                Me.rblActive.SelectedIndex = 0
                Me.txtSortOrder.Text = ""
                Me.litCreateDate.Text = ""
                Me.litModifyDate.Text = ""
            End If

        Catch ex As Exception
            Trace.Warn("loadSummary", "Error: " & ex.Message & "; " & ex.StackTrace)
        End Try
        objData.CloseConnection()
    End Sub



    '------------------------------------------------------------------------
    ' saving Information -- when creating item, or editing as admin
    '------------------------------------------------------------------------
    Public Sub SaveRecord(ByVal sender As Object, ByVal e As System.EventArgs)
        Trace.Write("saverecord", "ID=" & Me.litID.Text)
        Dim ID As String = Me.litID.Text
        If (ID = "") Then ID = "0"
        If (Not Page.IsValid) Then
            Exit Sub
        End If

        If ID = "0" Then ID = "-1"
        Dim p As CSL.Classes.Portfolio = CSL.Classes.PortfolioManager.GetItem(ID)
        If (p Is Nothing) Then
            p = New CSL.Classes.Portfolio
        End If
        p.PortfolioName = Me.txtPortfolioName.Text
        p.PortfolioDescription = Me.txtPortfolioDescription.Text
        p.CategoryID = RvDataUtil.Formatting.getDbIntNull(Me.drpcategoryID, 0)
        p.Image_thumb = Me.txtImage_thumb.Text
        p.Image_large = Me.txtImage_large.Text

        p.SortOrder = RvDataUtil.Formatting.getDbIntNull(Me.txtSortOrder.Text, 0)
        If (Me.rblDefaultCategoryImageFlag.SelectedIndex = 0) Then
            p.DefaultCategoryImageFlag = True
        Else
            p.DefaultCategoryImageFlag = False
        End If
        If (Me.rblActive.SelectedIndex = 0) Then
            p.ActiveFlag = True
        Else
            p.ActiveFlag = False
        End If

        p.Save()


        Me.pnlDatagrid.Visible = True
        Me.pnlEditForm.Visible = False
        Me.binddgList()


    End Sub


End Class

